<?php
/***************************************************************************
 *                               func_dli.php
 *                            DLIMP/DLTIC functions
 *                            -------------------
 *   begin                : Tuesday', Apr 22', 2006
 *   copyright            : ('C) 2006 Ulrich Schroeter
 *
 *     added              : Friday, July 28, 2006
 *                        : function hmac()
 *     modified           : updatearea() rep061030.032
 *     updated            : version() v2.05 rep061031.033
 *
 *
 ***************************************************************************/

/***************************************************************************
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License', or
 *   ('at your option) any later version.
 * See the LICENSE file for more information.
 * DLIMP Website : http://ambrosia60.dnsalias.net/
 *----------------------------------------------------------------------------
 */


define('FUNC_DLI',1);

//=================================================

/* ---------  begin funtions ------------------------------ */

// Want to Create a md5 HMAC, but don't have hmash installed?
// Use this:




// -----------------------------------------

function reset_dlmgmt($sfl1,$sfl2) {
  global $prefix, $db, $br;
  // update * of _dlmgmt value FE=False
  $qline = "UPDATE ".DLMGMT_TABLE." SET FE=0 WHERE l1 = '$sfl1' AND l2 = '$sfl2'";
  if (!$db->sql_query($qline)) {
    print "Query Result: Not Ok.".$br;
  } else {
    // print "DLMGMT reset Ok.".$br;
  }
}
// * end function reset_dlmgmt


// -----------------------------------------


// -----------------------------------------


// -----------------------------------------
//  $Lpart = elim($Lpart,"R24",1);
//  elim W97, Win97 but not 0.97 (!!)   $t > 0 ?
function elim($t,$s,$gk) {
  if ($gk != 0) {
    $ls = len($s);
    $lb = 0;
    while ($lb == 0) {
       if ((at($s,strtoupper($t))  > 0 ) OR (strtoupper(substr($t,0,$ls))==$s )) {
         $npos =  at($s,strtoupper($t));
         if ($npos==0) {
           $t = "   ".substr($t,$ls);
         } else {
           if ($s > 0) {
             if ((at(".".$s,strtoupper($t))  > 0 )) {
               $lb = 1;
             } else {
               $t = substr($t,0,$npos)."   ".substr($t,$npos+$ls);
             }
           } else {
             $t = substr($t,0,$npos)."   ".substr($t,$npos+$ls);
           }
         }
       } else {
         $lb = 1;
       }
    }
  } else {
    $ls = len($s);
    $lb = 0;
    while ($lb == 0) {
       if ((at($s,$t)  > 0 ) OR (substr($t,0,$ls)==$s )) {
         $npos =  at($s,$t);
         if ($npos==0) {
           $t = "   ".substr($t,$ls);
         } else {
           if ($s > 0) {
             if ((at(".".$s,$t)  > 0 )) {
               $lb = 1;
             } else {
               $t = substr($t,0,$npos)."   ".substr($t,$npos+$ls);
             }
           } else {
             $t = substr($t,0,$npos)."   ".substr($t,$npos+$ls);
           }
         }
       } else {
         $lb = 1;
       }
    }
  }
  return $t;
}

// -----------------------------------------
// subfunction vno?   vno(string,abg-test)
//  abg test:  alpha,beta,gamma 0 dont test, 1 test
//  returns version no    test upto 4 levels  #.#.#.#
//  if abg test, test also abg #  upto 4 levels #.#.#.#

function vno($ct,$abgt) {
  global $prefix, $db, $br;
  $r2txt = "";
  //$ct = $Rpart;
  $lct = len($ct);
  $jx = 0;
  while ($jx < $lct) {
    if ((strtolower(substr($ct,$jx,1))=="v") OR (strtolower(substr($ct,$jx,2))=="v.")) {
      $jy = $jx;
      if (strtolower(substr($ct,$jx,2))=="v.") {
        $jy = $jy+2;
      } else {
        $jy++;
      }
    } else {
      $jy = $jx;
    } 
    $jz = $jy;
    if (ereg("([0-9]{1})",substr($ct,$jy,1))) {
      //  num found
      while (ereg("([0-9]{1})",substr($ct,$jy,1))) {
        $jy++;
      }
      if (ereg("([.]{1})",substr($ct,$jy,1))) {
        $jy++;
        while (ereg("([0-9]{1})",substr($ct,$jy,1))) {
          $jy++;
        }
        if (ereg("([.]{1})",substr($ct,$jy,1))) {
          $jy++;
          while (ereg("([0-9]{1})",substr($ct,$jy,1))) {
            $jy++;
          }
          if (ereg("([.]{1})",substr($ct,$jy,1))) {
            $jy++;
            while (ereg("([0-9]{1})",substr($ct,$jy,1))) {
              $jy++;
            }
          }
        }
      }
      $r2txt = substr($ct,$jz,$jy-$jz);
      $jx = $lct;
      if ( (ereg("([a-z]{1})",strtolower(substr($ct,$jy,1)))) ) {
        $r2txt = $r2txt.substr($ct,$jy,1);
      } else {
        if ($abgt != 0) {
          $stest = strtolower(substr($ct,$jy));
          if ( (at("alpha",$stest)>0) OR (at("beta",$stest)>0) OR (at("gamma",$stest)>0) OR (ereg("sp([0-9]{1})",strtolower($stest)))  ) {
            if (at("alpha",$stest)>0) {
              $r2txt = $r2txt."-a";
            } else {
              if (at("beta",$stest)>0) {
                $r2txt = $r2txt."-b";
              } else {
                if (at("gamma",$stest)>0) {
                  $r2txt = $r2txt."-g";
                } else {
                  //  sp#
                  $r2txt = $r2txt.substr($stest,at("sp",$stest),3);
                }
              }
            }
          }
        }
      }
    }
    $jx++;
  }
  return $r2txt;
}

// -----------------------------------------

//   Version()  v2.05, 13.11.06  1:00

//            t1 = line 1 from files.bbs
//  optional  t2 = { line 2 from files.bbs connected by + }
//     or 
//            t1 = filename, description line 1
//
//  optional  vurl = filelink for fallback filedate as version number

function version($t1,$t2='',$vurl='') {
  global $prefix, $db, $br;
  // $br = "\n";
  $rtxt = "";

  //  Split into filename and description
  if ((substr($t1,13,1)=="[") AND ( ( (substr($t1,16,1)=="]") AND (ereg("([0-9]{2})",substr($t1,14,2))) ) OR ( (substr($t1,17,1)=="]") AND (ereg("([0-9]{3})",substr($t1,14,3))) ) ) ) {
    // identify files.bbs line  by [##] or [###] starting position 14
    $Lpart = ltrim(substr($t1,0,12));
    $tpart = substr($t1,16);     //    ] desc  or  0] desc
    $Rpart = substr($tpart,at(" ",$tpart)+1);
    if ($t2 <> "") {
       $t2 = ltrim($t2);
       if (substr($t2,0,1)=="+") {
         $Rpart = $Rpart." ".substr($t2,1);
       } else {
         $Rpart = $Rpart." ".$t2;
       }
    }
  } else {
    if ($t2 != "") {
      $Lpart = $t1;
      $Rpart = $t2;
    } else {
      // its Downloads Title:  filename, description ?  or  t1:filename, t2:description
      $Lpart = substr($t1,0,at(",",$t1));
      $Rpart = substr($t1,at(",",$t1)+2);
    }
  }

  $s1test = strtolower($Lpart);
  $s2test = strtolower($Rpart);
  if ( (at($s1test,$s2test)>0) OR (substr($s2test,0,len($s1test))==$s1test) ) {
    // remove exact filename from description to prevent dbl ptr false detection
    if (at($s1test,$s2test)>0) {
      $R1part = substr($Rpart,0,at($s1test,$s2test));
      $R2part = substr($Rpart,at($s1test,$s2test)+len($s1test));
      $Rpart = $R1part.$R2part;
    } else {
      $Rpart = substr($Rpart,len($s1test));
    }
      // echo "=== [DEBUG] ===".$br;
      // echo "L1 ... ".$Lpart.$br;
      // echo "R1 ... ".$Rpart.$br;
  }

       //echo "=== [DEBUG] ===".$br;
       //echo "L2 ... ".$Lpart.$br;
       //echo "R2 ... ".$Rpart.$br;




  // elim R24 and Z2 and 32 from filename and description to prevent false detections
  //  addtl. elim 95, 97, 98
  //  addtl. POP3, IMAP4

  $Lpart = elim($Lpart,"R24",1);
  $Lpart = elim($Lpart,"Z2PNT",1);
  $Lpart = elim($Lpart,"POP3",1);
  $Lpart = elim($Lpart,"IMAP4",1);
  $Lpart = elim($Lpart,"OS2",1);
  $Lpart = elim($Lpart,"CRC32",1);
  $Lpart = elim($Lpart,"###",1);
  $Lpart = elim($Lpart,"##",1);
  $Lpart = elim($Lpart," # ",1);


  $Rpart = elim($Rpart,"R24",1);
  $Rpart = elim($Rpart,"Z2PNT",1);
  $Rpart = elim($Rpart,"POP3",1);
  $Rpart = elim($Rpart,"IMAP4",1);
  $Rpart = elim($Rpart,"3.X",1);
  $Rpart = elim($Rpart,"OS/2",1);
  $Rpart = elim($Rpart,"CRC32",1);
  $Rpart = elim($Rpart,"###",1);
  $Rpart = elim($Rpart,"##",1);
  $Rpart = elim($Rpart," # ",1);


  //echo "=== [DEBUG] ===".$br;
  //echo $Lpart.$br;
  //echo $Rpart.$br;

  $ucLpart  = $Lpart;
  $ucRpart  = $Rpart;

  // check AFIX configuration about Primary Uplink aka for the system aka
  $bossnet  = "";
  $bossnode = "";

  $vq1 = $db->sql_query("SELECT * FROM ".DLICFG_TABLE." where config_name='AFIX09PAKA'");
  if ($vrow1 = $db->sql_fetchrow($vq1)) {
     $vpaka = $vrow1['config_value'];
     $vhlp1 = substr($vpaka,at(":",$vpaka)+1);
     $bossnet = substr($vhlp1,0,at("/",$vhlp1));
     $vhlp1 = substr($vpaka,at("/",$vpaka)+1);
     $bossnode = substr($vhlp1,0,at(".",$vhlp1));

     // echo $bossnet."\n";
     // echo $bossnode."\n";

     if (checkaka($Rpart) > 0) {
        $Rpart = removeaka($Rpart);
        // echo "Checkaka found aka. Remove aka: ".$Rpart.$br;
     }

     if ((at($bossnet,$Lpart)>0) and (at($bossnode,$Lpart)>0)) {
       $Lpart = substr($Lpart,at(".",$Lpart));

       $Rpart = elim($Rpart,$bossnet,1);
       $Rpart = elim($Rpart,$bossnode,1);
     }
  }



  //  identify filename body / extension split position .
  $BEpos = at(".",$Lpart);


  //  identify  #, vol, rc, no, nr, version and many others
  if  (( ereg("(v[0-9]+\.[0-9]+)",strtolower($Rpart)) ) OR ( ereg("(v\.[0-9]+\.[0-9]+)",strtolower($Rpart)) ) OR ( ereg("(v\.[0-9]+)",strtolower($Rpart)) )) {
    //  extract v#.# or v.#.#    probably v#.#.# ?
    // echo "=== [DEBUG] === 1".$br;
    //$rtxt = $Rpart;
    if  ( ereg("(v[0-9]+\.[0-9]+)",strtolower($Rpart),$regs) ) {
        //echo "v#.# found: ".$Rpart.$br;
        //echo "p1: ".$regs[1].$br;
        //echo "p2: ".$regs[2].$br;
    } else {
       if ( ereg("(v\.[0-9]+\.[0-9]+)",strtolower($Rpart),$regs) ) {
          //echo "v.#.# found: ".$Rpart.$br;
          //echo "p1: ".$regs[1].$br;
          //echo "p2: ".$regs[2].$br;
          //echo "p3: ".$regs[2].$br;
       } else {
           // ( ereg("(v\.[0-9]+)",strtolower($Rpart)) )
          //echo "v.# found: ".$Rpart.$br;
          //echo "p1: ".$regs[1].$br;
          //echo "p2: ".$regs[2].$br;
       }
    }
    $subRpart = substr($Rpart,at($regs[1],$Rpart));
    //echo "Subpart: ".$subRpart.$br;
    $rtxt = vno($subRpart,1);

  } else {
    $fnd = 0;
    if ( (ereg("([0-9]{1,3})( tag )",strtolower($Rpart))) or (ereg("( tag)([ |-])([0-9]{1,3})",strtolower($Rpart))) or (ereg("( day)([ |-])([0-9]{1,3})",strtolower($Rpart))) ) {
       //  check TAG or DAY cases
       if (ereg("([0-9]{1,3})( tag )",strtolower($Rpart),$regs)) {
           // tag
           $fnd = 1;
           $rtxt = $regs[1];
       } else {
           // tag #2
           if (ereg("( tag )([0-9]{1,3})/([0-9]{2})",strtolower($Rpart),$regs)) {
              $fnd = 1;
              $rtxt = $regs[2]."/".$regs[3];
              //  echo "p1: ".$regs[1].$br;
              //  echo "p2: ".$regs[2].$br;
              //  echo "p3: ".$regs[3].$br;
           } else {
              if (ereg("( tag)([ |-])([0-9]{1,3})",strtolower($Rpart),$regs)) {
                 $fnd = 1;
                 $rtxt = $regs[3];
              } else {
                 // day
                 if (ereg("( day )([0-9]{1,3})/([0-9]{2})",strtolower($Rpart),$regs)) {
                    $fnd = 1;
                    $rtxt = $regs[2]."/".$regs[3];
                    //  echo "p1: ".$regs[1].$br;
                    //  echo "p2: ".$regs[2].$br;
                    //  echo "p3: ".$regs[3].$br;
                 } else {
                    if (ereg("( day)([ |-])([0-9]{1,3})",strtolower($Rpart),$regs)) {
                       $fnd = 1;
                       $rtxt = $regs[3];
                       //  echo "p1: ".$regs[1].$br;
                       //  echo "p2: ".$regs[2].$br;
                       //  echo "p3: ".$regs[3].$br;
                    } else {
                       $fnd = 0;
                    }
                 }
              }
           }
       }
       // add /year if url is known and year can be extracted from filedate
       if (($fnd!=0) and (at("/",$rtxt)==0)) {
          if ($vurl!='') {
             if (substr($vurl,0,5)=="/drv_") {
                //  /drv_#/path/file format
                $pfilename = substr($vurl,5,1).":".substr($vurl,6);
                if (file_exists($pfilename)) {
                   // if (file_exists($areapath.$filename)) {
                   //  print "save: ".$filename.", ".$url.$br;
                   //  $fsize = filesize($areapath.$filename);
                   $dltime = date("Y-m-d H:i:s");
                   // file_exists($path.$filename)
                   $phyft = strftime("%Y-%m-%d %H:%M:%S",filemtime($pfilename));
                   $rtxt = $rtxt."/".substr($phyft,2,2);
                }
             } else {
                if (substr($vurl,1,2)==":/") {
                   //   Q:/path/file  format
                   $pfilename = $vurl;
                   if (file_exists($pfilename)) {
                      // if (file_exists($areapath.$filename)) {
                      //  print "save: ".$filename.", ".$url.$br;
                      //  $fsize = filesize($areapath.$filename);
                      $dltime = date("Y-m-d H:i:s");
                      // file_exists($path.$filename)
                      $phyft = strftime("%Y-%m-%d %H:%M:%S",filemtime($pfilename));
                      $rtxt = $rtxt."/".substr($phyft,2,2);
                   }
                }
             }
          }
       }
    }
    if ($fnd == 0) {
      //  check filename: ABCD     desc: AB/CD or CD/AB  condition
      if (  ( ereg("([0-9]{4})",$Lpart) ) AND ( ereg("([0-9]{2})/([0-9]{2})",$Rpart,$regs) )  ) {
        //echo "=== [DEBUG] === 2".$br;
        // sample      if (ereg ("([0-9]{4})-([0-9]{1,2})-([0-9]{1,2})", $date, $regs)) {
        //                echo "$regs[3].$regs[2].$regs[1]";
        //echo "=== [DEBUG] ===".$br;
        //echo "found condition #### in filename and ##/## in description".$br;
        //echo $Lpart.$br;
        //echo $Rpart.$br;
        //echo $regs[1]."/".$regs[2].$br;
        if ((at($regs[1],$Lpart)>0) OR (at($regs[2],$Lpart)>0)) {
           $fnd = 1;
           $rtxt = $regs[1]."/".$regs[2];
        }
      }
    }
    if ($fnd == 0) {
      // if (strtolower(substr($Lpart,0,5))=="fnews") {
      // if ( ( ereg("((?:(fnews|embbs|embul|gnews))([0-9,a-z]{1})([0-9]{2}))",strtolower($Lpart)) )  ) {
      if ( (ereg("(fnews([0-9,a-z]{1})([0-9]{2}))",strtolower($Lpart))) or (ereg("(embbs([0-9,a-z]{1})([0-9]{2}))",strtolower($Lpart))) or (ereg("(embul([0-9,a-z]{1})([0-9]{2}))",strtolower($Lpart))) or (ereg("(gnews([0-9,a-z]{1})([0-9]{2}))",strtolower($Lpart)))   ) {
         $V1part = substr($Lpart,5,1);
         $V2part = substr($Lpart,6,2);
         if (ereg("([0-9]+)",strtolower($V1part))) {
            // ok
            $rtxt = $V1part.".".$V2part;
         } else {
            // convert volume
            $avol = ord($V1part)-55;
            $rtxt = $avol.".".$V2part;
         }
      } else {
        //echo "=== [DEBUG] === 3".$br;


        $Lpart = elim($Lpart,"32",0);
        $Lpart = elim($Lpart,"95",0);
        $Lpart = elim($Lpart,"97",0);
        $Lpart = elim($Lpart,"98",0);

        $Rpart = elim($Rpart,"32",0);
        $Rpart = elim($Rpart,"95",0);
        $Rpart = elim($Rpart,"97",0);
        $Rpart = elim($Rpart,"98",0);
        $Rpart = elim($Rpart,"2000",0);

        // elim AKAs from filename and description to prevent false detections  ??
        //  ignore filename cause filename cannot build with  : / . special chars
        //if (checkaka($Lpart) > 0) {
        //   $Lpart = removeaka($Lpart);
        //}
        if (checkaka($Rpart) > 0) {
          $Rpart = removeaka($Rpart);
        }
        if (((at("#",$Rpart)>0) AND (at("##",$Rpart)==0) ) OR (at("version",strtolower($Rpart))>0) ) {
          //echo "=== [DEBUG] === 4".$br;
          // FIDONEWS 20 Feb 2006 Vol 23 No 08
          // Fidonews: Vol#23, Issue#09 for Feb. 27, 2006
          if (at("#",$Rpart)>0) {
            $tpart = rtrim(substr($Rpart,rat("#",$Rpart)+1));
            if (at(" ",$tpart) > 0) {
               $rtxt = substr($tpart,0,at(" ",$tpart));
            } else {
               $rtxt = $tpart;
            }
          } else {
            $tpart = rtrim(substr($Rpart,rat("version",strtolower($Rpart))+7));
            // echo "=== [DEBUG] ===".$br;
            // echo "version# ... ".$tpart.$br;
            if (at(" ",$tpart) > 0) {
               $chk = substr($tpart,0,at(" ",$tpart));
            } else {
               $chk = $tpart;
            }
            //     echo "=== [DEBUG] ===".$br;
            //     echo "version# 2.. ".$ct.$br;
            $rtxt = vno($chk,1);
          }
        }
      }
      if ($rtxt == "") {
        // if ((at("Vol ",$Rpart)>0) OR (at("No ",$Rpart)>0)) {
        if ((at("Vol ",$Rpart)>0) OR ( ereg("(no\b[0-9]+)",strtolower($Rpart)) )  ) {
          //  prevent "no description"

          //echo "=== [DEBUG] === 5".$br;
          // FIDONEWS 20 Feb 2006 Vol 23 No 08
          // use ucLpart, ucRpart
          $Lpart = $ucLpart;
          $Rpart = $ucRpart;
          if (at("No ",$Rpart)>0) {
            $tpart = rtrim(substr($Rpart,rat("No ",$Rpart)+3));
            if (at(" ",$tpart) > 0) {
               $rtxt = substr($tpart,0,at(" ",$tpart));
            } else {
               $rtxt = $tpart;
            }
            //echo "=== [DEBUG] ===".$br;
            //echo "No ... ".$tpart.$br;
          } else {
            // Vol
            $tpart = rtrim(substr($Rpart,rat("Vol ",$Rpart)+4));
            if (at(" ",$tpart) > 0) {
               $rtxt = substr($tpart,0,at(" ",$tpart));
            } else {
               $rtxt = $tpart;
            }
            //echo "=== [DEBUG] ===".$br;
            //echo "Vol ... ".$tpart.$br;
          }
        } else {
          if (at("Nr ",$Rpart)>0) {
            //echo "=== [DEBUG] === 6".$br;
            $tpart = rtrim(substr($Rpart,rat("Nr ",$Rpart)+3));
            if (at(" ",$tpart) > 0) {
              $rtxt = substr($tpart,0,at(" ",$tpart));
            } else {
              $rtxt = $tpart;
            }
            //echo "=== [DEBUG] ===".$br;
            //echo "Nr ... ".$tpart.$br;
          } else {
            //  check  alpha, beta, gamma
            $lRpart = strtolower($Rpart);
            if ( (at("alpha",$lRpart)>0) OR (at("beta",$lRpart)>0) OR (at("gamma",$lRpart)>0) ) {
              //echo "=== [DEBUG] === 7".$br;
              //   num? <- beta -> num?
              // analyze complete desc
              // mask  v#.#.#.# a/b/g ##
              //              <-- ^ -->
              // step1
              // |------------->
              // step2
              //                    |--->
              if (at("alpha",$lRpart)>0) {
                $f = "alpha";
                $fpos = at("alpha",$lRpart);
              } else {
                if (at("beta",$lRpart)>0) {
                  $f = "beta";
                  $fpos = at("beta",$lRpart);
                } else {
                  $f = "gamma";
                  $fpos = at("gamma",$lRpart);
                }
              }
              $R1part = substr($Rpart,0,$fpos);
              $R2part = substr($Rpart,$fpos+len($f));
              // echo "=== [DEBUG] ===".$br;
              // echo "Split alpha,beta,gamma ... ".$br;
              // echo "1: >".$R1part."<".$br;
              // echo "2: >".$R2part."<".$br;
              $R1part = vno($R1part,0);
              $R2part = vno($R2part,0);
              if ($R1part != "") {
                if ($R2part != "") {
                  if (len($R2part)>4) {
                     // prevent version + date combinations
                     $rtxt = $R1part."-".substr($f,0,1);
                  } else {
                     $rtxt = $R1part."-".substr($f,0,1).".".$R2part;
                  }
                } else {
                  $rtxt = $R1part."-".substr($f,0,1);
                }
              } else {
                if ($R2part != "") {
                  if (len($R2part)>4) {
                     $rtxt = $f;
                  } else {
                     $rtxt = $f."-".$R2part;
                  }
                } else {
                  $rtxt = $f;
                }
              }
            } else {
              //echo "=== [DEBUG] === 8".$br;
              //if (at("RC",strtoupper($Rpart))>0) {
              // may be release candidate
              //} else {
              //  the rest
              //  identify identical ## in filename and description
              //  nodediff.z62 -- nodediff day-062
              //  identify extension numbering
              $epart = substr($Lpart,$BEpos+1);
              $inum = 0;
              for ($jz=0; $jz < strlen($epart); $jz++) {
                if (ereg("([0-9]{1})",substr($epart,$jz,1))) {
                   $inum = 1;
                }
              }
              if (($inum != 0) AND (strlen($epart)==3)) {
                // numerical part identified and default extension length
                if (ereg("([0-9]{3})",substr($epart,0,3))) {
                   if (at($epart,$Rpart) > 0) {
                      // value found in description
                      $rtxt = $epart;
                      //echo "=== [DEBUG] ===".$br;
                      //echo "ext 3x# ... ".$epart.$br;
                   } else {
                      // value not found in description
                      $inum = 0;
                   }
                } else {
                   if (ereg("([0-9]{2})",substr($epart,1,2))) {
                     if (at(substr($epart,1,2),$Rpart) > 0) {
                        // value found in description
                        // nodediff.z62 -- nodediff day-062
                          //echo "=== [DEBUG] ===".$br;
                          //echo "ext 2x# ... ".$epart.$br;
                        $dpos = at(substr($epart,1,2),$Rpart)-1;
                          //echo "=== [DEBUG] ===".$br;
                          //echo "dpos ... ".$dpos.$br;
                          //echo "rpart dpos   ".substr($Rpart,$dpos,3).$br;
                          //echo "rpart dpos-1 ".substr($Rpart,$dpos-1,3).$br;
                          //echo "rpart dpos-2 ".substr($Rpart,$dpos-2,3).$br;
                        if (ereg("([0-9]{3})",substr($Rpart,$dpos,3))) {
                           $rtxt = substr($Rpart,$dpos,3);
                        } else {
                          //  #.## ?
                          //$inum = 0;
                          $rtxt = substr($Rpart,$dpos+1,2);
                        }
                     } else {
                        // value not found in description
                        $inum = 0;
                     }
                   } else {
                     if (ereg("([0-9]{1})",substr($epart,2,1))) {
                       if (at(substr($epart,2,1),$Rpart) > 0) {
                          // value found in description
                          //echo "=== [DEBUG] ===".$br;
                          //echo "ext 1x# ... ".$epart.$br;
                          $dpos = at(substr($epart,2,1),$Rpart);
                          if (ereg("([0-9]{1})",substr($Rpart,$dpos-1,1))) {
                             //  2 numbers ok
                             if (ereg("([0-9]{1})",substr($Rpart,$dpos-2,1))) {
                                // 3 numbers ok
                                $rtxt = substr($Rpart,$dpos-2,3);
                             } else {
                               $rtxt = substr($Rpart,$dpos-1,2);
                             }
                          } else {
                            $rtxt = substr($epart,2,1);
                          }
                       } else {
                          // value not found in description
                          $inum = 0;
                       }
                     } else {
                       // failure to identify, reset inum to check the rest
                       $inum = 0;
                     }
                   }
                }
              }
              if ($inum == 0) {
                //echo "=== [DEBUG] === 9".$br;
                //  the rest
                // check body filename for numbers, search number in description, starts on pos 2 (1 in php)
                // fe141     FastEcho 1.41
                //   ^^^              ^ ^^
                //   |                |
                //   pf               pd
                // $s1 = "ESIG9730.ZIP, ESig97 (v3.0) - E-Mail/Signature/Eudora";    // not ok, 97 should be 3.0
                //   check ALL numbers????
                //  elim  'ESIG97'  from testing?
                $body = substr($Lpart,0,$BEpos);
                $jz = -1;
                $lbody = strlen($body);
                //echo "=== [DEBUG] ===".$br;
                //echo "2 ptr check ... ".$body.$br;
                $fnd = 0;
                while ($jz < $lbody) {
                  $jz++;
                  //echo substr($body,$jz,1);
                  if (ereg("([0-9]{1})",substr($body,$jz,1))) {
                     //  num found in filename, test it in desc
                     $schar = substr($body,$jz,1);
                     if ((at($schar,$Rpart)>0) OR (($jz==0) AND ($schar==substr($Rpart,0,1)))) {
                       // number found in description, start loop
                       $pf = $jz;
                       $pfs = $pf;
                       $pd = at($schar,$Rpart);
                       $pds = $pd;
                       $l1stop = 0;
                       while ($l1stop != 1) {
                         $pf++;
                         $pd++;
                         $l2stop = 0;
                         if ($pf > $lbody) {
                           // no more chars to test
                           $l1stop = 1;
                         } else {
                           while ($l2stop != 1) {
                             if (substr($body,$pf,1)==substr($Rpart,$pd,1)) {
                               // continue loop
                               $l2stop = 1;
                             } else {
                               if (substr($Rpart,$pd,1)==".") {
                                  // inc pd
                                  $pd++;
                               } else {
                                  // stop loop
                                  $l2stop = 1;
                                  $l1stop = 1;
                               }
                             }
                           }
                         }
                       }
                       // correct to last ok pointers
                       $pf--;
                       $pd--;
                       // compare pd vs. pds, pf vs. pfs
                       if (($pd-$pds > 0) AND ($pf-$pfs > 0)) {
                          // next char A, B, C, D?
                          $test0 = substr($Rpart,$pds,$pd-$pds+1);
                          $test1 = strtolower(substr($Rpart,$pds,$pd-$pds+2));
                          if (($test0."a"==$test1) OR ($test0."b"==$test1) OR ($test0."c"==$test1) OR ($test0."d"==$test1)) {
                             if (at(".",$test0)>0) {
                                $test2 = removechar(".",$test0);
                             } else {
                                $test2 = $test0;
                             }
                             if (at($test2,$Lpart) > 0) {
                                $rtxt = substr($Rpart,$pds,$pd-$pds+2);
                                $fnd = 1;
                             } else {
                                $rtxt = substr($Rpart,$pds,$pd-$pds+1);
                                $fnd = 1;
                             }
                          } else {
                            //  pds -> pd
                            $rtxt = substr($Rpart,$pds,$pd-$pds+1);
                            $fnd = 1;
                            // stop main loop
                          }
                          $jz = $lbody;
                       }
                     }
                  }
                }
                //echo $br;
                if ($fnd == 0) {
                  //echo "=== [DEBUG] === 10".$br;
                  //   test num chars in filename and no num chars in description
                  //   use num in filename
                  $test0 = $Rpart;
                  $jz = -1;
                  $tlen = strlen($test0);
                  //     echo "=== [DEBUG] ===".$br;
                  //     echo "2nd num test in desc ... ".$test0.$br;
                  $fnd = 0;
                  while ($jz < $tlen) {
                    //  test numerical char in description
                    $jz++;
                    if (ereg("([0-9]{1})",substr($test0,$jz,1))) {
                      $fnd = 1;
                    }
                  }
                  if ($fnd ==0) {
                    //echo "=== [DEBUG] === 11".$br;
                    //  description without numbers. whats with ftn aka?
                    //  test filename body
                    $body = strtoupper(substr($Lpart,0,$BEpos+1));
                    $jz = -1;
                    $lbody = strlen($body);
                    //          echo "=== [DEBUG] ===".$br;
                    //          echo "2 ptr check ... ".$body.$br;
                    $fnd = 0;
                    while ($jz < $lbody) {
                      $jz++;
                      //            echo substr($body,$jz,1);
                      if (ereg("([0-9]{1})",substr($body,$jz,1))) {
                        //  num found, test it
                        // number found in filename, start loop
                        $pf = $jz;
                        $pfs = $pf;
                        //  $pd = at($schar,$Rpart);
                        //  $pds = $pd;
                        if (ereg("([0-9]{2})",substr($body,$jz,2))) {
                          if (ereg("([0-9]{3})",substr($body,$jz,3))) {
                            if (ereg("([0-9]{4})",substr($body,$jz,4))) {
                              $rtxt = substr($body,$jz,4);
                              $fnd = 1;
                              $jz = $lbody;
                            } else {
                              if (  (ereg("([A-Z]{1})",substr($body,$jz+3,1))) AND (substr($body,$jz+4,1)==".") ) {
                                //  case  ...123A.ZIP
                                $rtxt = substr($body,$jz,4);
                                $fnd = 1;
                                $jz = $lbody;
                              } else {
                                $rtxt = substr($body,$jz,3);
                                $fnd = 1;
                                $jz = $lbody;
                              }
                            }
                          } else {
                            if (  (ereg("([A-Z]{1})",substr($body,$jz+2,1))) AND (substr($body,$jz+3,1)==".") ) {
                              //  case  ...12A.ZIP
                              $rtxt = substr($body,$jz,3);
                              $fnd = 1;
                              $jz = $lbody;
                            } else {
                              $rtxt = substr($body,$jz,2);
                              $fnd = 1;
                              $jz = $lbody;
                            }
                          }
                        } else {
                          //  one single number only ...
                          if (  (ereg("([A-Z]{1})",substr($body,$jz+1,1))) AND (substr($body,$jz+2,1)==".") ) {
                            //  case  ...1A.ZIP
                            $rtxt = substr($body,$jz,2);
                            $fnd = 1;
                            $jz = $lbody;
                          } else {
                            $rtxt = substr($body,$jz,1);
                            $fnd = 1;
                            $jz = $lbody;
                          }
                        }
                      }
                    }
                  } else {
                    //echo "=== [DEBUG] === 12".$br;
                    $tpart = $Rpart;
                    $jz = -1;
                    $tlen = strlen($tpart);
                    //$tpart = rtrim(substr($Rpart,rat("version",strtolower($Rpart))+7));
                    //  echo "=== [DEBUG] ===".$br;
                    //  echo "2nd # test in desc ... ".$tpart.$br;
                    //if (at(" ",$tpart) > 0) {
                    //  $ct = substr($tpart,0,at(" ",$tpart));
                    //} else {
                    $rtxt = vno($tpart,1);
                  }
                }
              }
            }
          }
        }
      }
    }
  }
  if (at("(",$rtxt) > 0) {
     $rtxt = substr($rtxt,at("(",$rtxt)+1);
  }
  if (rat(")",$rtxt) > 0) {
     $rtxt = substr($rtxt,0,at(")",$rtxt));
  }

  if (at("_",$rtxt) > 0) {
     // prevent 24_INFO
     $hrtxt = strtolower($rtxt);
     if ((at("_alpha",$hrtxt) == 0) and (at("_beta",$hrtxt) == 0) and (at("_gamma",$hrtxt) == 0)) {
        $rtxt = substr($rtxt,0,at("_",$rtxt));
     }     
  }

  // last check, if version undefined and filename extension is numeric use last 2
  // extension digits to form version number x##
  if ($rtxt=="") {
     if ( ereg("(\.([a|z]{1})([0-9]{2}))",strtolower($ucLpart),$rgs2) ) {
        // extension is a00 or z00
        //echo $rgs2[0]."\n";
        //echo $rgs2[1]."\n";
        //echo $rgs2[2]."\n";
        //echo $rgs2[3]."\n";
        $rtxt = "x".$rgs2[3];
     } else {
       if ( ereg("(\.([0|1|2|3]{1})([0-9]{2}))",strtolower($ucLpart),$rgs2) ) {
          // extension is 000 or 100 or 200 or 300
          //echo $rgs2[0]."\n";
          //echo $rgs2[1]."\n";
          //echo $rgs2[2]."\n";
          //echo $rgs2[3]."\n";
          $rtxt = substr($rgs2[1],1);
       }
     }
  }

  // fallback: filedate
  if (($rtxt=="") and ($vurl!="")) {

     // 13.11.06  rep061110.041 fixes by chr()

     if (substr($vurl,0,5)==chr(47)."drv_") {
        //  /drv_#/path/file format
        $pfilename = substr($vurl,5,1).":".substr($vurl,6);

        if (file_exists($pfilename)) {
           $dltime = date("Y-m-d H:i:s");
           $phyft = strftime("%Y-%m-%d %H:%M:%S",filemtime($pfilename));
           $rtxt = substr($phyft,8,2).".".substr($phyft,5,2).".".substr($phyft,2,2);
        } else {
           $rtxt = "n/a";
           if (DEBUG != 0) {
              echo "DEBUG: [1] (URL) ".$vurl.$br;
           }
        }

     } else {

        if ((substr($vurl,1,2)==":".chr(47)) or (substr($vurl,1,2)==":".chr(92))) {
           //   Q:/path/file  format
           $vurl = str_replace(chr(92),chr(47),$vurl);
           $pfilename = $vurl;

           if (file_exists($pfilename)) {
              //$dltime = date("Y-m-d H:i:s");
              $phyft = strftime("%Y-%m-%d %H:%M:%S",filemtime($pfilename));
              $rtxt = substr($phyft,8,2).".".substr($phyft,5,2).".".substr($phyft,2,2);
           } else {
              $rtxt = "n/a";
              if (DEBUG != 0) {
                 echo "DEBUG: [2] (URL) ".$vurl.$br;
              }
           }

        } else {
           $rtxt = "n/a";
           if (DEBUG != 0) {
              echo "DEBUG: [3] (URL) ".$vurl.$br;
           }
        }

     }
  }

  return $rtxt;
}

// -----------------------------------------


//   t1 = line 1 from files.bbs
//   t2 = { line 2 from files.bbs connected by + }

//  end function version

// -----------------------------------------


// -----------------------------------------

function updatearea($cid,$l1,$l2) {
  global $prefix, $db, $br;
  global $fbbs,$homepage, $baseurl, $areapath, $areap2, $prog, $sitename, $email;
  global $AllowableHTML, $locale;

  reset_dlmgmt($l1,$l2);
  $flag = 0;
  $q0 = 0;
  $q1 = array();

  // read file workarea-path\files.bbs => $fbbs

  $fbbsa = array();
  $fbbsa = explode(chr(13).chr(10), $fbbs);
  $mxfbbsa = sizeof($fbbsa);

  $l = 0;
  
  while ($l < $mxfbbsa) {
    // line = readnextline(files.bbs)
    $dsave = 0;
    $line = rtrim($fbbsa[$l]);
    $l++;
    //print $l.") [".$line."]".$br;
    if ($flag==0) {
       // print "0".$br;
       if ($line <> "") {
         // print "line <> leer".$br;
         if (substr($line,0,1)<>" ") {
           // print "line pos 1 <> space".$br;
           //  first active line, filename, desc1
           $filename = strtoupper(substr($line,0,at(" ",$line)));

           // use homepage? or not? remove basepath too?
           // check also if file is saved in db with homepage,basepath informations

           // modified: rep061030.032
           //                http://url /1234/   /drv_q/path/ file
           $url3 = strtolower($homepage.$baseurl.substr($areap2,1).$filename);
           $url2 = strtolower($baseurl.substr($areap2,1).$filename);
           $url = strtolower($areap2.$filename);

           $subdesc = ltrim( substr($line,at("]",$line)+1) );
           if (eregi("'",$subdesc)) {
             $subdesc = ereg_replace("'","",$subdesc);
           }
           if (eregi("_",$subdesc)) {
             $subdesc = ereg_replace("_"," ",$subdesc);
           }
           $ttitle = $filename.", ".$subdesc;
           $found = 0;
           $r4lid = 0;
           // check also if file is saved in db with homepage,basepath informations
           $result4 = $db->sql_query("SELECT lid,url,title,filesize FROM ".DLIDL_TABLE." where (((url='$url') or (url='$url2') or (url='$url3')) and title='$ttitle')");
           while ($row4 = $db->sql_fetchrow($result4)) {
             $r4lid = intval($row4['lid']);
             $r4url = $row4['url'];
             $r4title = $row4['title'];
             $r4fsize = $row4['filesize'];
             $found = 1;
           }
           if ($found < 1) {
              // print "url not found or older file version in db, add new file".$br;
              //*  neuer File
              $flag = 1;
              $q0 = 0;
              $q1[$q0] = $line;
              //print "new file ".$line.$br;
           } else {
              // print "url found in db, only update FileExists".$br;
              $flag = 0;
              //  possible, file removed?
              if (file_exists($areapath.$filename) AND $r4lid > 0) {

                // if (file_exists($areapath.$filename)) {
                //  print "save: ".$filename.", ".$url.$br;
                $fsize = filesize($areapath.$filename);
                $dltime = date("Y-m-d H:i:s");

                // file_exists($path.$filename)
                $phyftime = strftime("%Y-%m-%d %H:%M:%S",filemtime($areapath.$filename));

                //  update(dlmgmt,lid,FE=True)

                if (ENABLE_FILEDATE) {
                  $qline = "UPDATE ".DLMGMT_TABLE." SET fe=1, filedate='".$phyftime."' WHERE lid = '$r4lid'";
                } else {
                  $qline = "UPDATE ".DLMGMT_TABLE." SET fe=1 WHERE lid = '$r4lid'";
                }
                $ok = $db->sql_query($qline);

                if ($fsize <> $r4fsize) {
                  $q2line = "UPDATE ".DLIDL_TABLE." SET filesize='$fsize', date='$dltime', submitter='".PROG."' WHERE lid = '$r4lid'";
                  $ok = $db->sql_query($q2line);
                }

                //print "update file ".$line.$br;
              }
           }
         //} else {
         //  * skip
         }
       //} else {
       //  * skip
       }
    } else {
       // print "1".$br;
       // flag == 1, in active execution
       if ($line=="") {
          // print "line = empty".$br;
          // execution break by empty line, do save of temp infos in q1[]
          $dsave = 1;         
       } else {
         // print "line <> empty".$br;
         if (substr($line,0,1)<>" ") {
           // print "line pos 1 <> space".$br;
           // * previous found File, infos in q1 array check, save, FE = True
           $dsave = 1;
         }
       }
       if ($dsave > 0) {
         // print "save = ON".$br;
         $flag=0;
         $hline = $q1[0];
         $filename = strtoupper(substr($hline,0,at(" ",$hline)));

         //  url w/o homepage?
         // check also if file is saved in db with homepage,basepath informations

         // modified: rep061030.032
         //                http://url /1234/   /drv_q/path/ file
         $url3 = strtolower($homepage.$baseurl.substr($areap2,1).$filename);
         $url2 = strtolower($baseurl.substr($areap2,1).$filename);
         $url = strtolower($areap2.$filename);

         $subdesc = ltrim( substr($hline,at("]",$hline)+1) );
         if (eregi("'",$subdesc)) {
           $subdesc = ereg_replace("'","",$subdesc);
         }
         if (eregi("_",$subdesc)) {
           $subdesc = ereg_replace("_"," ",$subdesc);
         }
         $title = $filename.", ".$subdesc;
         $desc = $subdesc." ";
         if ($q0>0) {
            for ($q2=1; $q2 <= $q0; $q2++) {
                if (ltrim($q1[$q2])<>"") {
                   if (substr(ltrim($q1[$q2]),0,1)=="+") {
                      $subdesc = substr(ltrim($q1[$q2]),1);
                      if (eregi("'",$subdesc)) {
                        $subdesc = ereg_replace("'","",$subdesc);
                      }
                      if (eregi("_",$subdesc)) {
                        $subdesc = ereg_replace("_"," ",$subdesc);
                      }
                      $desc .= $subdesc." ";
                   } else {
                      $subdesc = substr(ltrim($q1[$q2]),0);
                      if (eregi("'",$subdesc)) {
                        $subdesc = ereg_replace("'","",$subdesc);
                      }
                      if (eregi("_",$subdesc)) {
                        $subdesc = ereg_replace("_"," ",$subdesc);
                      }
                      $desc .= $subdesc." ";
                   }
                }
            }
         }
         $desc = rtrim($desc);
         if ($title<>"" AND $filename<>"") {
           // print "title and filename not empty".$br;
           if (file_exists($areapath.$filename)) {
             print "save: ".$filename.", ".$url.$br;
             $fsize = filesize($areapath.$filename);
             $phyftime = strftime("%Y-%m-%d %H:%M:%S",filemtime($areapath.$filename));
             $dltime = date("Y-m-d H:i:s");
             if ($q0 > 0) {
               $vrsn = version($q1[0],$q1[1],$areapath.$filename);
             } else {
               $vrsn = version($q1[0],'',$areapath.$filename);
             }
             $title = addslashes(StripQuotes($title));
             $url = addslashes(FixQuotes($url));
             $desc = addslashes(StripQuotes($desc));
             $sitename = addslashes(StripQuotes($sitename));
             $email = addslashes(StripQuotes($email));
             $vrsn = addslashes(StripQuotes($vrsn));
             $qline = "insert into ".DLIDL_TABLE." values (NULL,".$cid.",0,'".$title."','".$url."','".$desc."','".$dltime."','".$sitename."','".$email."',0,'".PROG."',0,0,0, '$fsize', '$vrsn', '$homepage')";
             if (!$db->sql_query($qline)) {
               print "save record _DOWNLOADS_DOWNLOADS failed.".$br;
             } else {
               // identify highest lid, save in dlmgmt
               $row6 = $db->sql_fetchrow($db->sql_query("SELECT lid,cid FROM ".DLIDL_TABLE." WHERE lid>0 ORDER BY lid DESC"));
                  $r6lid = intval($row6['lid']);
                  $r6cid = intval($row6['cid']);

                //  update(dlmgmt,lid,FE=True)

               if (ENABLE_FILEDATE) {
                 $qline = "INSERT INTO ".DLMGMT_TABLE." VALUES (NULL,".$r6lid.",".$r6cid.",0,".$l1.",".$l2.",1,'".$phyftime."')";
               } else {
                 $qline = "INSERT INTO ".DLMGMT_TABLE." VALUES (NULL,".$r6lid.",".$r6cid.",0,".$l1.",".$l2.",1)";
               }
               if (!$db->sql_query($qline)) {
                 print "save record _DOWNLOADS_DLMGMT failed.".$br;
               }
             }
           }
         }
       }
       if ($line=="") {
         // skip to next line
         $q0 = 0;
         $q1 = array();
       } elseif (substr($line,0,1)<>" ") {
         $q0 = 0;
         $q1 = array();
         //  reset for next file
         $filename = substr($line,0,at(" ",$line));

         //  url w/o homepage?
         // check also if file is saved in db with homepage,basepath informations

         // modified: rep061030.032
         //                http://url /1234/         /drv_Q/path/  file
         $url3 = strtolower($homepage.$baseurl.substr($areap2,1).$filename);
         $url2 = strtolower($baseurl.substr($areap2,1).$filename);
         $url = strtolower($areap2.$filename);

         $subdesc = ltrim( substr($line,at("]",$line)+1) );
         if (eregi("'",$subdesc)) {
           $subdesc = ereg_replace("'","",$subdesc);
         }
         if (eregi("_",$subdesc)) {
           $subdesc = ereg_replace("_"," ",$subdesc);
         }
         $ttitle = $filename.", ".$subdesc;
         $found = 0;
         $r4lid = 0;
         // check also if file is saved in db with homepage,basepath informations
         $result4 = $db->sql_query("SELECT lid,url,title,filesize FROM ".DLIDL_TABLE." where (((url='$url') or (url='$url2') or (url='$url3')) and title='$ttitle')");
         while ($row4 = $db->sql_fetchrow($result4)) {
           $r4lid = intval($row4['lid']);
           $r4url = $row4['url'];
           $r4title = $row4['title'];
           $r4fsize = $row4['filesize'];
           $found = 1;
         }
         if ($found < 1) {
            // print "url not found in db, add new file".$br;
            //*  neuer File
            $flag = 1;
            $q0 = 0;
            $q1[$q0] = $line;
            //print "add file ".$line.$br;
         } else {
            // print "url found in db, only update FileExists".$br;
            $flag = 0;
            //  possible, file removed?
            if (file_exists($areapath.$filename) AND $r4lid > 0) {
              // if (file_exists($areapath.$filename)) {
              //  print "save: ".$filename.", ".$url.$br;
              $fsize = filesize($areapath.$filename);
              $dltime = date("Y-m-d H:i:s");
              $phyftime = strftime("%Y-%m-%d %H:%M:%S",filemtime($areapath.$filename));

              //  update(dlmgmt,lid,FE=True)
              if (ENABLE_FILEDATE) {
                $qline = "UPDATE ".DLMGMT_TABLE." SET fe=1, filedate='".$phyftime."' WHERE lid = '$r4lid'";
              } else {
                $qline = "UPDATE ".DLMGMT_TABLE." SET fe=1 WHERE lid = '$r4lid'";
              }
              $ok = $db->sql_query($qline);
              //print "update file ".$line.$br;

              
              if ($fsize <> $r4fsize) {
                $q2line = "UPDATE ".DLIDL_TABLE." SET filesize='$fsize', date='$dltime', submitter='".PROG."' WHERE lid = '$r4lid'";
                $ok = $db->sql_query($q2line);
              }

            }
         }
       } else {
         // 2nd, 3rd and so on description lines until empty line or new line with filename
         $q0 = $q0 + 1;
         $q1[$q0] = $line;
         //print "add line ".$line.$br;
       }
    }
  // sleep(20);
  }
  if ($flag>0) {
     $flag=0;
     $hline = $q1[0];
     $filename = substr($hline,0,at(" ",$hline));

     // url w/o homepage?
     // check also if file is saved in db with homepage,basepath informations

     // modified: rep061030.032
     //                http://url /1234/         /drv_Q/path/  file
     $url3 = strtolower($homepage.$baseurl.substr($areap2,1).$filename);
     $url2 = strtolower($baseurl.substr($areap2,1).$filename);
     $url = strtolower($areap2.$filename);

     $subdesc = ltrim( substr($hline,at("]",$hline)+1) );
     if (eregi("'",$subdesc)) {
       $subdesc = ereg_replace("'","",$subdesc);
     }
     if (eregi("_",$subdesc)) {
       $subdesc = ereg_replace("_"," ",$subdesc);
     }

     $title = $filename.", ".$subdesc;
     $desc = $subdesc." ";
     if ($q0>0) {
        for ($q2=1; $q2 <= $q0; $q2++) {
           if (ltrim($q1[$q2])<>"") {
             if (substr(ltrim($q1[$q2]),0,1)=="+") {
               $subdesc = substr(ltrim($q1[$q2]),1);
               if (eregi("'",$subdesc)) {
                 $subdesc = ereg_replace("'","",$subdesc);
               }
               if (eregi("_",$subdesc)) {
                 $subdesc = ereg_replace("_"," ",$subdesc);
               }
               $desc .= $subdesc." ";
             } else {
               $subdesc = substr(ltrim($q1[$q2]),0);
               if (eregi("'",$subdesc)) {
                 $subdesc = ereg_replace("'","",$subdesc);
               }
               if (eregi("_",$subdesc)) {
                 $subdesc = ereg_replace("_"," ",$subdesc);
               }
               $desc .= $subdesc." ";
             }
           }
        }
     }
     $desc = rtrim($desc);
     if ($title<>"" AND $filename<>"") {
        if (file_exists($areapath.$filename)) {
          print "save: ".$filename.", ".$url.$br;
          $fsize = filesize($areapath.$filename);
          $dltime = date("Y-m-d H:i:s");
          $phyftime = strftime("%Y-%m-%d %H:%M:%S",filemtime($areapath.$filename));

          if ($q0 > 0) {
             $vrsn = version($q1[0],$q1[1],$areapath.$filename);
          } else {
             $vrsn = version($q1[0],'',$areapath.$filename);
          }
          $title = addslashes(StripQuotes($title));
          $url = addslashes(FixQuotes($url));
          $desc = addslashes(StripQuotes($desc));
          $sitename = addslashes(StripQuotes($sitename));
          $email = addslashes(StripQuotes($email));
          $vrsn = addslashes(StripQuotes($vrsn));
          $qline = "insert into ".DLIDL_TABLE." values (NULL,".$cid.",0,'".$title."','".$url."','".$desc."','".$dltime."','".$sitename."','".$email."',0,'".PROG."',0,0,0, '$fsize', '$vrsn', '$homepage')";
          if (!$db->sql_query($qline)) {
             print "save record _DOWNLOADS_DOWNLOADS failed.".$br;
          } else {
             // identify highest lid, save in dlmgmt
             $row6 = $db->sql_fetchrow($db->sql_query("SELECT lid,cid FROM ".DLIDL_TABLE." WHERE lid>0 ORDER BY lid DESC"));
                $r6lid = intval($row6['lid']);
                $r6cid = intval($row6['cid']);

             if (ENABLE_FILEDATE) {
               $qline = "INSERT INTO ".DLMGMT_TABLE." VALUES (NULL,".$r6lid.",".$r6cid.",0,".$l1.",".$l2.",1,'".$phyftime."')";
             } else {
               $qline = "INSERT INTO ".DLMGMT_TABLE." VALUES (NULL,".$r6lid.",".$r6cid.",0,".$l1.",".$l2.",1)";
             }
             if (!$db->sql_query($qline)) {
                print "save record _DOWNLOADS_DLMGMT failed.".$br;
             }
          }
        }
     }
  }
 // * check dlmgmt
 // result = sqlquery(dlmgmt, l1=l1, l2=l2, not FE)
 $result5 = $db->sql_query("SELECT lid FROM ".DLMGMT_TABLE." where l1='$l1' and l2='$l2' and fe=0");
 // * alle jetzt gefundenen Records sind nicht mehr in der Filebase vorhanden => Lschen
 while ($row5 = $db->sql_fetchrow($result5)) {
     $templid = intval($row5['lid']);
     $delete_rec_sql = "DELETE FROM ".DLIDL_TABLE." WHERE lid IN ($templid)";
     if ( !$db->sql_query($delete_rec_sql, BEGIN_TRANSACTION) ) {
        print "delete record _DOWNLOADS_DOWNLOADS failed.".$br;
     }
     $delete_rec_sql = "DELETE FROM ".DLMGMT_TABLE." WHERE lid IN ($templid)";
     if ( !$db->sql_query($delete_rec_sql, BEGIN_TRANSACTION) ) {
        print "delete record _DOWNLOADS_DLMGMT failed.".$br;
     }
 }
 // * end function updatearea
}

// -----------------------------------------



/* ---------  end funtions  ------------------------------ */


?>
